<template>
	<view class="box">
		<image src="https://wjh-1300238208.cos.ap-guangzhou.myqcloud.com/jsb/static/login_logo.jpg" mode=""></image>
    <view>需求你授权才能使用哦~</view>
		<button open-type="getPhoneNumber"  @getphonenumber="getphonenumber"> 微信用户登录 </button>
		<view class="mask" v-if="sub" catchtouchmove="function(){ return false}">
			<view class="sub">
				<view>
					<image src="https://wjh-1300238208.cos.ap-guangzhou.myqcloud.com/jsb/static/login_logo.jpg" mode=""></image>
					<view>请允许微信头像和昵称授权<br>我们对您的信息进行保密</view>
					<button open-type="getUserInfo"  lang="zh_CN"  @getuserinfo="bindGetUserInfo"> 立即授权 </button>
				</view>
			</view>
		</view>
	</view>
</template>

<script lang="ts">
	import { Component, Vue, Watch } from "vue-property-decorator"

	@Component({})
	export default class Home extends Vue {
	
    // 微信注册 
    private wechatData = {} as _account._pwxRegister

		// 组件是否可用
    private canIUse: boolean = uni.canIUse('button.open-type.getUserInfo')
    
    // 立刻授权
    private sub: boolean = false

		// scope.userinfo
		private scopeStatus: boolean = false

		// 扫码二维码
		private code = '' as string

		// 页面加载
		async onLoad(options: any) {
			this.code = options.code
			await this.login()
			let setting: any = await uni.getSetting()
			if (!setting[1] || setting[1].errMsg != 'getSetting:ok') {
				return uni.showToast({
					title: '微信api异常！',
					icon: 'none'
				})
			}
			this.scopeStatus = setting[1].authSetting['scope.userInfo']

			if (!this.scopeStatus) return false
		}

		toast(title?: string) {
			uni.showToast({
				title: title || '微信api异常！',
				icon: 'none'
			})
		}

		// 微信登录
		async login() {
			let data: any = await uni.login()
			// console.info('login',data)
			if (!data[1] || data[1].errMsg != 'login:ok') {
				return this.toast()
			}
			this.wechatData.jsCode = data[1].code
			// console.info('login',this.wechatData)
			return true
		}

		// 微信注册
		async wxReg() {
			const res: _account._rwxRegister = await this.$API._accountwxRegister({ data: this.wechatData })
			if (!res || res.code !== '0000') return this.sub = true
			
			Object.assign(this.wechatData, { token:  res.data.token})

			const userinfo = await this.getUserinfo()
			if (!userinfo) {
				await this.login()
				return this.sub = true
			}

			Object.assign(this.wechatData, userinfo)
			
			const memberres: _memberinfo._redit = await this.$API._memberInfoedit({ data: userinfo as _memberinfo._pedit })
			if (!memberres || memberres.code !== '0000') return uni.showToast({
				title: '注册失败',
				icon: 'none',
				duration: 2000
			})

			uni.showToast({
				title: '注册成功',
				icon: 'none',
				duration: 2000
			})

			if (this.code) 
				return setTimeout(() => {
					uni.navigateTo({
						url: `/pages/home?code=${this.code}`
					})
				}, 2000)
			
			setTimeout(() => {
				uni.navigateBack({
					delta: 1
				})
			}, 2000)
		}

		// 获取用户数据
		async bindGetUserInfo(e: any) {
			if (e.detail.errMsg != "getUserInfo:ok") return this.toast('登录失败')
			// this.wechatData.iv = e.detail.iv
      // this.wechatData.encryptedData = e.detail.encryptedData

			Object.assign(this.wechatData, e.detail.userInfo)
	
			this.wxReg()
		}

		// 获取用户信息
		async getUserinfo() {
			let data: any = await uni.getUserInfo({
				lang: 'zh_CN'
			})
			if (!data[1] || data[1].errMsg != 'getUserInfo:ok') {
				return false
			}
			return data[1].userInfo
		}

		// 获取手机号码
		async getphonenumber(e: any) {
      if (e.detail.errMsg != "getPhoneNumber:ok") return false
      this.wechatData.iv = e.detail.iv
			this.wechatData.encryptedData = e.detail.encryptedData
			Object.assign(this.wechatData, { appKey: '123456' })
			this.wxReg()
		}

	}
</script>

<style lang="scss" scoped>
	body{
		overflow: hidden;
	}
	.box {
		overflow: hidden;
	}
	.box>image {
		width: 200rpx;
		height: 200rpx;
		border-radius: 50%;
		margin: 120rpx 275rpx 60rpx 275rpx;
  }
  
  .box>view {
    width: 750rpx;
    text-align: center;
    font-size: 26rpx;
    font-family: PingFang SC;
    font-weight: 500;
    color:rgba(153,153,153,1);
    margin-bottom: 107rpx;
  }

	.box>button {
		width: 400rpx;
    height: 88rpx;
    background:linear-gradient(90deg,rgba(57,110,107,1),rgba(91,150,158,1));
    border-radius: 44rpx;
    font-size: 32rpx;
    font-family: PingFang SC;
    font-weight: 500;
    color: rgba(255,255,255,1);
	}

  
  .sub {
		>view {
			width: 530rpx;
			height: 662rpx;
			background-color: #FFFFFF;
			image {
				width: 228rpx;
				height: 228rpx;
				margin: 80rpx 151rpx 47rpx 151rpx;
			}
			view {
				width: 320rpx;
				margin-left: 105rpx;
			}
			button{
				margin-top:  74rpx;
				width: 400rpx;
				height: 88rpx;
				background:linear-gradient(90deg,rgba(57,110,107,1),rgba(91,150,158,1));
				border-radius: 44rpx;
				font-size: 32rpx;
				font-family: PingFang SC;
				font-weight: 500;
				color: rgba(255,255,255,1);
			}
		}
  }
</style>
